# Contributing to HTTPLab
Welcome and thanks for showing interest in contributing to the project.
HTTPLab is an opensource so its success depend on your help. Your contributions are going to help many HTTPLab users directly.

There are many ways you can contribute, here's how:

- [Asking aquestions](#asking-question)
- [Writing code](#writing-code)
- [Improving documentation](#improving-documentation)
- [Reporting Bugs](#reporting-bugs)

## Asking questions
What seems obvious for one person might not be for other, there's different backgrounds, context and way of thinking.
Don't be shy if something is not clear, just ask.
We use the [issue](https://github.com/gchaincl/httplab/issues) tracker for this,
so please *make sure your question hasn't been replied* before opening a new issue.

## Writing code
If you fix a bug, or introduce a new feature, make sure that:
* **No one else is already working on that**. Review the open pull requests (see [#In Progress](https://github.com/gchaincl/httplab/issues?q=is%3Aopen+is%3Aissue+label%3A%22In+Progress%22) issues)  before start working on it.
* Whenever is possible, **add tests**
* Try to follow the conventions
* Keep the pull request small
* Document the public API.

## Improving documentation
Documentation is as important as code, undocumented features are unexisting features.
If you think documentation is insufficient or imprecise, please open a [pull request](https://github.com/gchaincl/httplab/pulls).
We treat documentation problems as bugs, so make sure you've read the [Fixing bugs](#fixing-bugs) before.

## Reporting bugs
Bug reports are valuable information, and will help make HTTPLab better.
Be expressive enough to make developer's job as easy as possible, so make sure the report includes the step to reproduce it.
